// AlphaBlend sample - Plugin for PhotoFiltre
// Copyright Antonio DA CRUZ - December 2004

library PlgBlend;

uses
  Windows,
  Graphics,
  Forms,
  Plugin,
  Params in 'Params.pas' {ParamsForm};

{$R *.res}

const
  Copyright = 'Antonio Da Cruz';
  Version = '1.0';

  // franais
  ErrorMsgFR = 'Impossible d''excuter le module !';
  CaptionFR = 'Effet de transparence...';
  CommentFR = 'Module de dmonstration !';

  // anglais
  ErrorMsgEN = 'Unable to process the plugin !';
  CaptionEN = 'AlphaBlend effect...';
  CommentEN = 'Sample plugin !';

function RegisterCompatibility: Integer; stdcall;
begin
  Result := 2; // to use Image object
end;

function RegisterPluginLanguage: PPluginLanguage; stdcall;
begin
  Result := PtrPlgLanguage;
end;

function RegisterPluginHeader: PPluginHeader; stdcall;
begin
  SetHeaderPluginType(ptFilter);
  SetHeaderAuthor(Copyright);
  SetHeaderVersion(Version);
  if GetLanguageCode = 'FR' then
  begin
    SetHeaderCaption(CaptionFR);
    SetHeaderComment(CommentFR);
  end
  else
  begin
    SetHeaderCaption(CaptionEN);
    SetHeaderComment(CommentEN);
  end;
  Result := PtrPlgHeader;
end;

function RegisterPluginStruct: PPluginStruct; stdcall;
begin
  Result := PtrPlgStruct;
end;

function RegisterPluginGlyph: HBitmap; stdcall;
begin
  Result := LoadBitmap(HInstance, PChar('GLYPH'));
end;

// Don't export this function for Delphi <= 5
procedure RegisterApplication;
begin
  Application.Handle := MainHandle;
end;

function Execute: Integer; stdcall;
begin
  // message d'erreur
  if GetLanguageCode = 'FR' then PluginErrorMsg := ErrorMsgFR
  else PluginErrorMsg := ErrorMsgEN;
  try
    RegisterApplication;
    ParamsForm := TParamsForm.Create(Application);
    try
      ParamsForm.Show;
      PrepareDialog(ParamsForm.Handle, doPreview, True, True);
      Result := Ord(ParamsForm.DialogResult);
    finally
      ParamsForm.Free;
    end;
  except
    Result := 0;
  end;
end;

exports
  RegisterCompatibility name 'RegisterCompatibility',
  RegisterPluginLanguage name 'RegisterPluginLanguage',
  RegisterPluginHeader name 'RegisterPluginHeader',
  RegisterPluginStruct name 'RegisterPluginStruct',
  RegisterPluginGlyph name 'RegisterPluginGlyph',  
  Execute name 'Execute';
  
begin
end.
