// Effet miroir sur une image

// Copyright Antonio DA CRUZ - Janvier 2004
// Merci de ne pas modifier les sources sans mon autorisation !

// Ce plugin est de type Image
// Renommez le fichier compil 'Miroir.dll' en 'Miroir.pfl' et placez-le
// dans le dossier 'Plugins' de PhotoFiltre

library Miroir;

uses
  Windows,
  Graphics,
  Forms,
  Plugin,
  Params in 'Params.pas' {ParamsForm};

{$R *.res}

const
  Copyright = 'Antonio Da Cruz';
  Version = '1.3';

  // franais
  ErrorMsgFR = 'Impossible d''excuter le module !';
  CaptionFR = 'Effet miroir...';
  CommentFR = 'Cration d''effet miroir sur une image';

  // anglais
  ErrorMsgEN = 'Unable to process the plugin !';
  CaptionEN = 'Mirror effect...';
  CommentEN = 'Create mirror effect on image';

function RegisterCompatibility: Integer; stdcall;
begin
  Result := 1;
end;

function RegisterApplication: PApplication; stdcall;
begin
  Result := @Application;
end;

function RegisterPluginLanguage: PPluginLanguage; stdcall;
begin
  Result := PtrPlgLanguage;
end;

function RegisterPluginHeader: PPluginHeader; stdcall;
begin
  SetHeaderPluginType(ptImage);
  SetHeaderAuthor(Copyright);
  SetHeaderVersion(Version);
  if GetLanguageCode = 'FR' then
  begin
    SetHeaderCaption(CaptionFR);
    SetHeaderComment(CommentFR);
  end
  else
  begin
    SetHeaderCaption(CaptionEN);
    SetHeaderComment(CommentEN);
  end;
  Result := PtrPlgHeader;
end;

function RegisterPluginStruct: PPluginStruct; stdcall;
begin
  Result := PtrPlgStruct;
end;

function RegisterPluginGlyph: HBitmap; stdcall;
begin
  Result := LoadBitmap(HInstance, PChar('GLYPH'));
end;

function Execute: Integer; stdcall;
begin
  // message d'erreur
  if GetLanguageCode = 'FR' then PluginErrorMsg := ErrorMsgFR
  else PluginErrorMsg := ErrorMsgEN;
  try
    ParamsForm := TParamsForm.Create(Application);
    try
      ShowForm(ParamsForm, doModal, True, True);
      Result := Ord(ParamsForm.DialogResult);
    finally
      ParamsForm.Free;
    end;
  except
    Result := 0;
  end;
end;

exports
  RegisterCompatibility name 'RegisterCompatibility',
  RegisterApplication name 'RegisterApplication',
  RegisterPluginLanguage name 'RegisterPluginLanguage',
  RegisterPluginHeader name 'RegisterPluginHeader',
  RegisterPluginStruct name 'RegisterPluginStruct',
  RegisterPluginGlyph name 'RegisterPluginGlyph',  
  Execute name 'Execute';
  
begin
end.
